/*
  Calculadora em Notação Polaca Inversa - pretende-se desenvolver uma
  calculadora com as operações aritméticas elementares (adição,
  subtracção, multiplicação e divisão).

  Para simplificar a tarefa vai-se considerar que as expressões a
  introduzir estão em notação pósfixa (notação Polaca Inversa).
*/

#include <iostream>
#include <string>
#include <sstream>
#include "pilhasInt.h"

using namespace std;

int main() {
  Pilha p1;
  string aux;
  int operando,op1,op2,res;

  cout << "Introduza uma expressão em NPI\n";
  cout << "(um elemento por linha '.' para terminar)\n\n";

  cout << "introduza um elemento da expressão:\t";
  cin >> aux;
  while (aux!=".") {
    // se é um operando
    if ((aux=="+") || (aux=="*") || (aux=="-") || (aux=="/")) {
      // retira da pilha os dois operandos
      op2 = p1.top();
      p1.pop();
      op1 = p1.top();
      p1.pop();
      // faz o cálculo
      if (aux=="+")
	res = op1+op2;
      if (aux=="*")
	res = op1*op2;
      if (aux=="-")
	res = op1-op2;
      if (aux=="/")
	res = op1/op2;
      // coloca o resultado na pilha
      p1.push(res);
    }
    else { // é um operando
      // converte par inteiro
      // http://www.cplusplus.com/reference/iostream/stringstream/
      stringstream ss(aux);
      ss >> operando;
      // coloca-o na pilha
      p1.push(operando);
    }
    // lê um novo elemento da expressão
    cout << "introduza um elemento da expressão:\t";
    cin >> aux;
  }
  // Após terminar o ciclo o resultado está no topo da pilha (que
  // aliás só contém esse elemento)
  res =  p1.top();
  cout << "O resultado da expressão é:\t" << res << endl;
}


