#ifndef PILHAS
#define PILHAS

#include <iostream>
#include "pilhasInt.h"

#endif

// constructor
Pilha::Pilha(int sz){
  // a Pilha vai ser definido como um vector de dimensão "sz" 
  topo = pilha = new int[tamanho=sz];
};

// destructor
Pilha::~Pilha(){
  delete [] pilha;
};

// push
void Pilha::push(int c){
  topo++;
  *topo = c;
};

// pop
void Pilha::pop(){
  --topo;
};

// top
int Pilha::top(){
  return *topo;
};

// ?vazia
int Pilha::vazia(){
  return(pilha==topo);
}
