class Pilha {
public:
  // construtor
  Pilha(int sz = Tamanho_por_omissao);
  // destrutor
  ~Pilha();
  // manipuladores
  void cria();
  void push(int);
  void pop();
  int top();
  int vazia();
private:
  int tamanho;
  static const int Tamanho_por_omissao = 10;
  int *topo, *pilha;
  // inviabilizar a inicialização por cópia
  Pilha(const Pilha&) {};
  // inviabilizar a atribuição
  void operator=(const Pilha&) {};
};



